--[[
************************************************************************
Project				: Broker_Extractor
Author				: zhinjio
Project Revision	: r4
Project Date		: 20081122153123

File				: Broker_Extractor.lua
Commit Author		: zhinjio
Commit Revision		: 4
Commit Date			: 20081122153123
************************************************************************
Description	:
	Main addon file. 

TODO		:

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

local MODNAME = "Extractor"
local FULLNAME = "Broker_Extractor"
local Extractor = LibStub( "AceAddon-3.0" ):NewAddon( MODNAME, "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( MODNAME )
local AceConfig 		= LibStub("AceConfig-3.0")
local AceConfigReg 		= LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 	= LibStub("AceConfigDialog-3.0")

_G[ MODNAME ] = Extractor
local addon = Extractor

local addonversion = "r4"
local addonauthor = "zhinjio"
local builddate = "20081122153123"

local modularOptions = {}
local tooltip
local LTT = LibStub:GetLibrary( "LibQTip-1.0" )

-- addon globals
-- addon.someValue = 0
addon.VERSION = 1.0
addon.me = ""
addon.currTT = 0

local db

function addon.Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\" .. FULLNAME .. "\\icon:" .. fh .. "\124t"
	if ( msg ~= nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " " .. MODNAME .. " " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function addon.Debug( msg )
	if ( msg ~= nil ) then
		if ( db.options.display.debug ) then
			addon.Print( "DEBUG: " .. msg )
		end
	end
end
-- my custom tooltips have particular herbs and zones in them. store those values here
addon.ttHerbs = {
	[0] = "22710 2447 765 2449 785 2450 2452 2453 3820",
}
addon.ttZones = {
	[0] = "20 14 50 31 19 5 15 44 23 30 39 46 53 11 41 3 54 26 16 34 40",
}
-- LDB stuff
local LDB = LibStub( "LibDataBroker-1.1" )
local launcher = LDB:NewDataObject( MODNAME, {
	type = "launcher",
	text = MODNAME,
	label = MODNAME,
	icon = "Interface\\Addons\\" .. FULLNAME .. "\\icon",
	OnClick = function(clickedframe, button) addon:ShowConfig() end,
	OnEnter = function ( self )
		tooltip:Clear()
		tooltip:AddHeader( MODNAME )
		tooltip:AddLine(" ")
		-- here's the custom stuff
		if ( addon.currTT == 0 ) then
			-- Header line
			local t, z = {}, {}
			t[1] = 1;		z[1] = 1
			t[2] = "LEFT";	z[2] = " "
			local index = 3
			for i in addon.ttHerbs[addon.currTT] do
				local _, _, _, _, _, _, _, _, _, icon = GetItemInfo[i]
				t[1] = index; table.insert( t, "CENTER" )
				z[1] = index; table.insert( z, "\124T" .. icon .. ":32\124t" )
				index = index + 1
			end
			tooltip:SetColumnLayout( unpack( t ) )
			tooltip:AddLine( unpack ( z ) )				
			addon.currTT = 1
		elseif ( addon.currTT == 1 ) then
			tooltip:AddLine( "tt2" )
			addon.currTT = 2
		elseif ( addon.currTT == 2 ) then
			tooltip:AddLine( "tt2" )
			addon.currTT = 3
		else
			tooltip:AddLine( "tt2" )
			addon.currTT = 0
		end
		-- end of custom stuff
		tooltip:AddLine(" ")
--		tooltip:AddLine( L["Left-Click for Stuff"] )
--		tooltip:AddLine( L["Right-click for Configuration"] )
		tooltip:AddLine( L["Click for Configuration"] )

		tooltip:SmartAnchorTo( self )
		tooltip:Show()
	end,
	OnLeave = function ( )
		tooltip:Hide()
	end,
} )

function addon.upgradeDB()
	local olddb = addon.db.factionrealm[addon.me]
	if ( olddb.options.display.dbVersion == "1.0" ) then
		-- original version
		olddb.options.display.debug = false
		olddb.options.display.dbVersion = "1.1"
		addon.Print( string.format( L["Database upgraded to %s"], "1.1" ) )
	end
end


-- options stuff
local displayOptions = nil
local function giveDisplay()
	if (not displayOptions) then
		displayOptions = {
			order = 2,
			type = "group",
			name = L["Display Options"],
			desc = L["DISPLAY_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 21,
					type	= "header",
					name	= L["Display Options"],
				},
				desc = {
					order	= 22,
					type	= "description",
					name	= L["DISPLAY_OPTIONS_DESC"],
				},
				sound = {
					order	= 23,
					type	= "toggle",
					name	= L["Enable DEBUG"],
					desc	= L["DISPLAY_DEBUG_DESC"],
					get		= function() return db.options.display.debug end,
					set		= function() db.options.display.debug = not db.options.display.debug end,
				},
				tooltipscale = {
					order	= 24,
					type	= "range",
					name	= L["Tooltip Scale"],
					desc	= L["TOOLTIP_SCALE_DESC"],
					min		= .7,
					max		= 1.3,
					step	= .05,
					bigStep = .05,
					get		= function() return db.options.display.tipscale end,
					set		= function( info, v ) 
								db.options.display.tipscale = v
								tooltip:SetScale( v )
							  end,
				},
			},
		}
	end
	return displayOptions
end

local options = nil
local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["General Information"],
					desc	= L["GENERAL_INFO_DESC"],
					args	= {
						header1 = {
							order	= 11,
							type	= "header",
							name	= L["General Information"],
						},
						desc = {
							order	= 12,
							type	= "description",
							name	= L["GENERAL_INFO_DESC"],
						},
						author = {
							order	= 13,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 14,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 15,
							type	= "description",
							name	= L["Build Date : "] .. builddate .. "\n",
						},
						dbversion = {
							order	= 15,
							type	= "description",
							name	= L["Database Version : "] .. db.options.display.dbVersion .. "\n",
						},
						translators = {
							order	= 16,
							type	= "description",
							name	= string.format( L["Helpful Translators (thank you) : %s"], " \n" )
						},
					},
				},
			},
		}
	end
	
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end

	return options
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")

	-- Fill up our modular options...
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function addon:ShowConfig()
	-- Open the profiles tab before, so the menu expands
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

-- coloring agents
local function Brown ( text )
	return "|cffcf8107" .. text .. "|r"
end
local function Yellow( text )
	return "|cffffff00" .. text .. "|r"
end
local function White( text )
	return "|cffffffff" .. text .. "|r"
end

function addon.AddExtractData( tt, itemID, itemName, toggle )
	tt:AddLine( " " )
	local miner = {}
	if ( toggle == 1 ) then
		tt:AddLine( Brown( itemName .. L[" extracts into :"] ) )
		miner = addon.MinedData[itemID]
		if ( miner ~= nil ) then
			local times = miner.times
			local yields = miner.yielded
			table.sort( yields, function( a, b ) return a.times > b.times end )
			for k, v in pairs( yields ) do
				local oName, oPerc = "", ""
				if ( v.max == 1 ) then
					oName = "  " .. GetItemInfo( k )
				else
					oName = "  " .. GetItemInfo( k ) .. "(" .. v.min .. "-" .. v.max .. ")"
				end
				if ( times ~= 0 ) then
					oPerc = string.format( "%.1f%%", ( v.times / times * 100 ) )
				else
					oPerc = "?"
				end
				tt:AddDoubleLine( Yellow( oName ), White( oPerc ) )
			end
		else
			tt:AddLine( Brown( L["No Extraction Statistics Found"] ) )
		end
	else
		tt:AddLine( Brown( itemName .. L[" extracted from :"] ) )
		miner = addon.MinedResults[itemID]
		if ( miner ~= nil ) then
			for k, v in pairs( miner ) do
				local oName, oPerc = "", ""
				if ( v.max == 1 ) then
					oName = "  " .. GetItemInfo( k )
				else
					oName = "  " .. GetItemInfo( k ) .. "(" .. v.min .. "-" .. v.max .. ")"
				end
				if ( v.tries ~= 0 ) then
					oPerc = string.format( "%.1f%%", ( v.yields / v.tries * 100 ) )
				else
					oPerc = "?"
				end
				tt:AddDoubleLine( Yellow( oName ), White( oPerc ) )
			end
		else
			tt:AddLine( Brown( L["No Extraction Statistics Found"] ) )
		end
	end
	tt:AddLine( " " )
end

local Orig_GameTooltip_SetItem = GameTooltip:GetScript("OnTooltipSetItem")
GameTooltip:SetScript("OnTooltipSetItem", function( tooltip, ... )
	if Orig_GameTooltip_SetItem then
		Orig_GameTooltip_SetItem( tooltip, ... )
	end
	if ( tooltip ) then
		local name, link = tooltip:GetItem()
		if ( link ) then
			local itemID = string.match( link, "item:(%d+)" ) + 0
			if ( addon.Extractables[itemID] == true ) then
				addon.AddExtractData( tooltip, itemID, name, 1 )
			elseif( addon.Extracteds[itemID] == true ) then
				addon.AddExtractData( tooltip, itemID, name, 0 )
			end
		end
	end
end)

local Orig_ItemRefTooltip_SetItem = ItemRefTooltip:GetScript("OnTooltipSetItem")
ItemRefTooltip:SetScript("OnTooltipSetItem", function(tooltip, ...)
	if Orig_ItemRefTooltip_SetItem then
		Orig_ItemRefTooltip_SetItem(tooltip, ...)
	end
	if ( tooltip ) then
		local name, link = tooltip:GetItem()
		if ( link ) then
			local itemID = string.match( link, "item:(%d+)" ) + 0
			if ( addon.Extractables[itemID] == true ) then
				addon.AddExtractData( tooltip, itemID, name, 1 )
			elseif( addon.Extracteds[itemID] == true ) then
				addon.AddExtractData( tooltip, itemID, name, 0 )
			end
		end
	end
end)

function addon:OnInitialize()
	-- Do Frame Creation stuff here
	-- addon:CreateFrames()
end

function addon:OnEnable()
    -- Called when the addon is loaded
	addon.me = UnitName( "player" )

	self.db = LibStub( "AceDB-3.0" ):New( MODNAME .. "_DB", nil, "Default" )
	-- do we have any data yet; for this toon? If not, init its table
	if not ( self.db.factionrealm[addon.me] ) then
		self.db.factionrealm[addon.me] = {
		-- Your saved variables stuff here
			options = {
				display = {
					debug = false,
					tipscale = 1,
					dbVersion = "1.1",
				},
			},
		}
	else
		-- check if we need to upgrade the db
		addon.upgradeDB()
	end
	db = self.db.factionrealm[addon.me]

	addon.Debug( "In OnInit" )

	tooltip = LTT:Acquire( MODNAME.."TT", 3, "LEFT", "CENTER", "RIGHT" ) -- or GameTooltip
	tooltip:SetScale( db.options.display.tipscale )

	addon:SetupOptions()
	-- Event listeners
    -- addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

--[[
************************************************************************
CHANGELOG:

11/20/08 : 
	Initial version
************************************************************************
]]--